#ifndef GENERIC_API__SYMBOL_MAPPER_TCL_HH
#define GENERIC_API__SYMBOL_MAPPER_TCL_HH

#include <ldasgen_config.h>

#include <tcl.h>

#include "genericAPI/SymbolMapper.hh"

namespace GenericAPI
{
  namespace TCL
  {
    class SymbolMapper
      : public ::GenericAPI::SymbolMapper
    {
    public:
      SymbolMapper( Tcl_Interp* Interp );

      virtual ~SymbolMapper( );

      static void Create( Tcl_Interp* Interp );

    protected:
      virtual void addSymbol( const std::string& Symbol,
			      arg_type Arg,
			      func_type Function );

    private:
      Tcl_Interp*	m_interp;

      Tcl_Interp* interp( );

      static char* change_callback( ClientData CD,
				    Tcl_Interp* Interp,
				    CONST84 char* Name1,
				    CONST84 char* Name2,
				    int Flags );
    };

    inline Tcl_Interp* SymbolMapper::
    interp( )
    {
      return m_interp;
    }
  }
}

#endif /* GENERIC_API__SYMBOL_MAPPER_TCL_HH */
